/*
 Library for RTC
 */


#include "Arduino.h"
#include "Wire.h"
#include "RTCLib.h"

RTCLib::RTCLib()		// Contructor
{
}

bool RTCLib::begin(void)
{
	zero = 0x00;
	return true;
}

bool RTCLib::program_RTC(void)	// Program RTC
{
	Serial.println("Entering RTC Programming Mode");
	Serial.println("To program the RTC correctly choose a time in the future (about 2 minutes in the future)");
	Serial.println("You will enter all information for that time.  Then the program will wait for");
	Serial.println("your command at that specified time.");
	delay(3000);
	
Enter_Values:	
	
	Serial.println("Enter the Year (0-99)");
	if (Serial.available() > 0) {
		year = Serial.read();
	}		
	Serial.println("Enter the Month (1-12)");
	if (Serial.available() > 0) {
		month = Serial.read();
	}
	Serial.println("Enter the Day of the Month (1-31)");
	if (Serial.available() > 0) {
		monthDay = Serial.read();
	}
	Serial.println("Enter the Day of the Week (1-7)");
	if (Serial.available() > 0) {
		weekDay = Serial.read();
	}
	Serial.println("Enter the Hour (0-23)");
	if (Serial.available() > 0) {
		hour = Serial.read();
	}
	Serial.println("Enter the Minute (0-59)");
	if (Serial.available() > 0) {
		minute = Serial.read();
	}
	Serial.println("Enter the Second (0-59)");
	if (Serial.available() > 0) {
		second = Serial.read();
	}
	
	Serial.println("System ready to program RTC for:");
	Serial.print(month); Serial.print(" ");
	Serial.print(monthDay); Serial.print(" 20");
	Serial.print(year); Serial.print("     ");
	Serial.print(hour); Serial.print(":");
	Serial.print(minute); Serial.print(":");
	Serial.println(second);
	
	Serial.println("Is this information correct? (Y/N)");
	if (Serial.available() > 0) {
		answer = Serial.read();
	}
	if(answer == 'Y'){
		Serial.println("Prepare to program RTC...");
		delay(3000);
		Serial.print("When your time is exactly: ");
		Serial.print(month); Serial.print(" ");
		Serial.print(monthDay); Serial.print(" 20");
		Serial.print(year); Serial.print("     ");
		Serial.print(hour); Serial.print(":");
		Serial.print(minute); Serial.print(":");
		Serial.print(second);
		Serial.print(" Type the word \"program\" and press enter.");
		if (Serial.read() == 'program') {
			Wire.beginTransmission(DS1307_ADDRESS);
			Wire.write(zero); //stop Oscillator
			Wire.write(decToBcd(second));
			Wire.write(decToBcd(minute));
			Wire.write(decToBcd(hour));
			Wire.write(decToBcd(weekDay));
			Wire.write(decToBcd(monthDay));
			Wire.write(decToBcd(month));
			Wire.write(decToBcd(year));
			Wire.write(zero); //start
			Wire.endTransmission();
		}
	}else{
		goto Enter_Values;
	}
	
		Serial.println();
		Serial.print("RTC programmed to: ");
		Serial.print(month); Serial.print(" ");
		Serial.print(monthDay); Serial.print(" 20");
		Serial.print(year); Serial.print("     ");
		Serial.print(hour); Serial.print(":");
		Serial.print(minute); Serial.print(":");
		Serial.print(second);
		
	return true;
}

void RTCLib::RTC_printDate(void){

	// Reset the register pointer
	Wire.beginTransmission(DS1307_ADDRESS);
	Wire.write(zero);
	Wire.endTransmission();

	Wire.requestFrom(DS1307_ADDRESS, 7);

	int second = bcdToDec(Wire.read());
	int minute = bcdToDec(Wire.read());
	int hour = bcdToDec(Wire.read() & 0b111111); //24 hour time
	int weekDay = bcdToDec(Wire.read()); //0-6 -> sunday - Saturday
	int monthDay = bcdToDec(Wire.read());
	int month = bcdToDec(Wire.read());
	int year = bcdToDec(Wire.read());

	//print the date EG   3/1/11 23:59:59
	//Serial.print(month);
	//Serial.print("/");
	//Serial.print(monthDay);
	//Serial.print("/");
	//Serial.print(year);
	//Serial.print(" ");
	//Serial.print(hour);
	//Serial.print(":");
	//Serial.print(minute);
	//Serial.print(":");
	//Serial.println(second);

}

unsigned char RTCLib::decToBcd(unsigned char val){
	// Convert normal decimal numbers to binary coded decimal
	return ( (val/10*16) + (val%10) );
}

unsigned char RTCLib::bcdToDec(unsigned char val)  {
	// Convert binary coded decimal to normal decimal numbers
	return ( (val/16*10) + (val%16) );
}







