/*
  Library for RTC
*/


#ifndef RTCLib_h			// ensure this library description is only included once
#define RTCLib_h

#define DS1307_ADDRESS 0x68		// I2C Address
	

// library interface description
class RTCLib {
  public:
	  //FUNCTIONS WITH VARIABLES USED IN FUNCTIONS AND VARIABLE TYPES

	RTCLib();
	bool begin(void);
	bool program_RTC(void);
	void RTC_printDate(void);
	unsigned char decToBcd(unsigned char val);
	unsigned char bcdToDec(unsigned char val);
	
	// Variables
	unsigned char zero;//0x00;//workaround for issue #527	
	unsigned char second; //0-59
	unsigned char minute; //0-59
	unsigned char hour; //0-23
	unsigned char weekDay; //1-7
	unsigned char monthDay; //1-31
	unsigned char month; //1-12
	unsigned char year; //0-99
	char answer;

};

#endif

